#!/usr/bin/env ruby

require 'gtk2'
require "rexml/document"

def create_popup(menu, parent, panel, window, http_expas, xml_frag, blz)
	mennew = Gtk::MenuItem.new("Neue Bank hinzufügen")
	mendel = Gtk::MenuItem.new("Diese Bank löschen")
	menadd = Gtk::MenuItem.new("Einzelnen Server hinzufügen")

	menu.append(mennew)
	menu.append(mendel)
	menu.append(menadd)

	mennew.signal_connect('activate') { |w| 
		select_bank(window, panel)
	}
	mendel.signal_connect('activate')  { |w|
		# $stderr.puts bpos.to_s 
		$stderr.puts blz
		delete_bank(blz.to_i)
		parent.expanded = false
		parent.sensitive = false
	}
	menadd.signal_connect('activate') { |w|
		add_single_host(window, http_expas, xml_frag) 
	}
	menu.show_all
end

def delete_bank(blz)
	$deleted_banks.push(blz)
	$removed_hosts = true
	puts $deleted_banks.join(", ")
	puts $bankfrags.keys.join(", ")
end

def add_single_host(window, http_expas, xml_frag)
	host_to_add = nil
	host_frag = xml_frag.elements["hosts[@class='http']"]
	# $stderr.puts host_frag.to_s
	dialog = Gtk::Dialog.new(
	"Server hinzufügen",
	window,
	Gtk::Dialog::MODAL,
	[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ])
	dialog.has_separator = false

	entry = Gtk::Entry.new
	hbox = Gtk::HBox.new(false, 5)
	hbox.border_width = 10
	hbox.pack_start_defaults(entry);
	dialog.vbox.add(hbox)
	dialog.show_all
	dialog.run { |res|
		if res == Gtk::Dialog::RESPONSE_OK
			host_to_add = entry.text
		end
		dialog.destroy
	}
	unless host_to_add.nil?
		# $stderr.puts(xml_frag.to_s)
		chebo = Gtk::CheckButton.new(host_to_add)
		# host_frag
		host_xnode = host_frag.add_element("host")
		host_xnode.add_attribute("name", host_to_add)
		host_xnode.add_attribute("active", "no")
		chebo.active = false
		chebo.signal_connect("toggled") { |c|
			if c.active? == false
				host_xnode.attributes["active"] = 'no' 
				$removed_hosts = true
			else
				host_xnode.attributes["active"] = 'yes'
			end
			# $stderr.puts host_frag.to_s
			
		}
		http_expas.pack_start(chebo)
		http_expas.show_all
	end
end

def prep_blz_list(blzxml)
	blzlist = Array.new
	blzxml.elements.each("banklist/bank") { |node|
		if node.attributes["blz"].to_i > 0
			blzlist.push(node.attributes["blz"])
			blzlist.push(node.attributes["url"])
		end
	}
	blzlist.sort!
	blzlist.uniq!
	return blzlist
end

def search_matching_xml(identifyer)
	valid_blzs = Array.new
	valid_host = nil
	valid_blz = nil
	valid_name = nil
	isblz = false
	isblz = true if identifyer.to_i > 0
	$blzxml.elements.each("banklist/bank") { |node|
		if isblz == true
			if node.attributes["blz"] == identifyer.strip
				valid_host = node.attributes["url"]
				valid_blz = node.attributes["blz"]
				valid_name = node.attributes["name"]
				$stderr.puts("BLZ found!")
			end
		else
			if node.attributes["url"] == identifyer.strip
				valid_host = node.attributes["url"]
				valid_blz = node.attributes["blz"]
				valid_name = node.attributes["name"]
				valid_blzs.push(node.attributes["blz"])
			end
		end
	}
	if isblz == true
		if system("test -f " + $blzdir + "/" + identifyer + ".xml")
			xmlfrag = REXML::Document.new(File.new($blzdir + "/" + identifyer + ".xml"))
			return xmlfrag, valid_blz, valid_name
		end
		$blzxml.elements.each("banklist/bank") { |node|
			if node.attributes["url"] == valid_host
				# valid_blz = node.attributes["blz"]
				# valid_name = node.attributes["name"]
				valid_blzs.push(node.attributes["blz"])
				$stderr.puts("VALID BLZ FOR FOUND HOST " + node.attributes["blz"] ) # , valid_blz, valid_name
			end
		}
	end
	valid_blzs.each { |b|
		$stderr.puts("VALID BLZ FOR KNOWN HOST " + b)
		if system("test -f " + $blzdir + "/" + b + ".xml")
			xmlfrag = REXML::Document.new(File.new($blzdir + "/" + b + ".xml"))
			return xmlfrag, valid_blz, valid_name
		end
	}
	return nil
end

def select_bank(pwin, panel)
	dialog = Gtk::Dialog.new(
	"Banksuche",
	pwin,
	Gtk::Dialog::MODAL,
	[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ])
	dialog.has_separator = false
	label = Gtk::Label.new("The button was clicked!")
	image = Gtk::Image.new(Gtk::Stock::DIALOG_INFO, Gtk::IconSize::DIALOG)

	hbox = Gtk::HBox.new(false, 5)
	hbox.border_width = 10
	model = Gtk::ListStore.new(String)
	comen = Gtk::ComboBoxEntry.new(model, 0)
	hbox.pack_start_defaults(comen);
	dialog.vbox.add(hbox)
	dialog.show_all
	comen.signal_connect("key-release-event") { |x, y|
		narrow_banklist(comen, comen.active_text)
	}
	identifyer = nil
	dialog.run { |response|
		case response
		when Gtk::Dialog::RESPONSE_OK
			identifyer = comen.active_text
			$stderr.puts("Search for: " + comen.active_text)
		end
		dialog.destroy
	}
	xml_fragment, blz, name = search_matching_xml(identifyer)
	add_bank(xml_fragment.root, panel, pwin, blz, name ) unless xml_fragment.nil?
	# return xml_fragment
end

def narrow_banklist(combo_entry, typed_text)
	$stderr.puts typed_text
	iter = combo_entry.model
	iter.clear
	narrow_list = Array.new
	$blzlist.each { |item|
		if item =~ Regexp.new("^" + typed_text) ||  item =~ Regexp.new("^www." + typed_text)
			narrow_list.push(item)
		end
	}
	if narrow_list.size > 0 && narrow_list.size <= 50
		narrow_list.each { |n|
			newrow = iter.append
			newrow[0] = n
		}
	end
	combo_entry.popup if narrow_list.size > 1 && narrow_list.size <= 20
end

def write_back(parent)
	doc = REXML::Document.new
	doc.add_element("allowedbanks")
	$bankfrags.each { |k, v|
		if $deleted_banks.include?(k)
			$stderr.puts("Skipping deleted bank: " + k.to_s)
		else
			# $stderr.puts("Dumping XML fragment: " + v.to_s)
			doc.root.add(v)
		end
	}
	# $stderr.puts(doc.to_s)
	outfile = File.open($cfgdir + "/allowedservers.xml", "w")
	doc.write( outfile, 4)
	outfile.close
	write_smack_rules
	if $removed_hosts == true
		show_warning(parent, "Achtung: Aus der Liste gelöschte Server sind noch bis zum nächsten Neustart aktiv!")
	end
end

def write_smack_rules
	valid_hosts = Array.new
	valid_ips = Array.new
	$bankfrags.each { |k, v|
		if $deleted_banks.include?(k)
			$stderr.puts("Skipping deleted bank: " + k.to_s)
		else
			v.elements.each("hosts/host") { |h|
				if h.attributes["active"] == "yes"
					# $stderr.puts(h.attributes["name"])
					valid_hosts.push(h.attributes["name"])
				end
			}
		end
	}
	valid_hosts.uniq!
	valid_hosts.each { |h|
		inside_answer = false
		# $stderr.puts("Valid: " + h)
		if check_for_ip(h) == true
			valid_ips.push(h)
		else
			IO.popen("nslookup '" + h + "'") { |io|
				while io.gets
					toks = $_.split
					inside_answer = true if toks[0] =~ /^Name:/
					if inside_answer == true && !toks[1].nil? && toks[0] =~ /^Address:/
						valid_ips.push(toks[1])
					elsif inside_answer == true && !toks[2].nil? && toks[0] =~ /^Address/ && toks[1] =~ /:$/
						valid_ips.push(toks[2])
					end
				end
			}
		end
	}
	# Add nameservers to valid_ips
	File.open("/etc/resolv.conf").each { |line|
		toks = line.split
		valid_ips.push(toks[1].strip) if toks[0].strip =~ /^nameserver/
	}
	system("rm " + $outdir + "/smack.netlabel.???.txt")
	valid_ips.uniq!
	ofcount = 0
	valid_ips.each { |ip|
		$stderr.puts("Dumping: " + ip)
		outfile = File.open($outdir + "/smack.netlabel." + sprintf("%03d", ofcount) + ".txt", 'w')
		outfile.write(ip + " outgoing\n") 
		outfile.close
		system("cat " + $outdir + "/smack.netlabel." + sprintf("%03d", ofcount) + ".txt > /smack/netlabel")
		ofcount += 1
	}
end

def show_warning(parent, text)
	dialog = Gtk::MessageDialog.new(parent, 
			Gtk::Dialog::MODAL,
			Gtk::MessageDialog::WARNING,
			Gtk::MessageDialog::BUTTONS_CLOSE,
			text)
	dialog.run
	dialog.destroy
end

def check_for_ip(host_or_ip)
	toks = host_or_ip.split(".")
	return false unless toks.size == 4
	return false if toks[0].to_i < 2
	toks.each { |t|
		return false if t.to_i < 1 || t.to_i > 255 
	}
	return true
end

def add_bank(xbnode, pwidget, window, blz, name)
	# First check if bank already exists, abort with an error if
	# this should be the case
	if $bankfrags.has_key?(blz)
		dialog = Gtk::Dialog.new(
		"Bank existiert bereits",
		window,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ]
		)
		dialog.has_separator = false
		label = Gtk::Label.new("Diese Bank existiert bereits in der Liste!")
		image = Gtk::Image.new(Gtk::Stock::DIALOG_ERROR, Gtk::IconSize::DIALOG)

		hbox = Gtk::HBox.new(false, 5)
		hbox.border_width = 10
		hbox.pack_start_defaults(image);
		hbox.pack_start_defaults(label);
		dialog.vbox.add(hbox)
		dialog.show_all
		dialog.run
		dialog.destroy
		return nil
	end
	# puts b.attributes["name"] + " " + b.attributes["blz"]
	bank_expa = Gtk::Expander.new("")
	bank_expa.use_markup = true
	$stderr.puts("<b>" + name.to_s + " (" + blz.to_s + ")</b>")
	bank_expa.label = "<b>" + name.to_s + " (" + blz.to_s + ")</b>"
	
	# We need a VBox to pack the following http/https expanders
	bank_box = Gtk::VBox.new(false, 0)
	
	# An auxiliary HBox is used to provide the gap for the https expander
	bank_auxbox1 = Gtk::HBox.new(false, 0)
	bank_expa_https = Gtk::Expander.new("")
	bank_expa_https.use_markup = true
	bank_expa_https.label = "<b>Sichere Verbindungen</b>"
	bank_auxbox1.pack_start(bank_expa_https, false, 0, 20)
	
	# An auxiliary HBox to provide the gap left of the checkboxes
	# An VBox to contain the checkboxes
	check_vbox = Gtk::VBox.new(false, 0)
	check_hbox = Gtk::HBox.new(false, 0)
	xbnode.elements.each("hosts[@class='https']/host") { |host|
		$stderr.puts host.attributes["name"]
		chebo = Gtk::CheckButton.new(host.attributes["name"])
		chebo.active = true if host.attributes["active"] == 'yes'
		chebo.signal_connect("toggled") { |c|
			if c.active? == false
				host.attributes["active"] = 'no' 
				$removed_hosts = true
			else
				host.attributes["active"] = 'yes'
			end
			$stderr.puts xbnode.to_s
		}
		check_vbox.pack_start(chebo)
	}
	check_hbox.pack_start(check_vbox, false, 0, 20)
	bank_expa_https.add(check_hbox)
	
	# An auxiliary HBox is used to provide the gap for the http expander
	bank_auxbox2 = Gtk::HBox.new(false, 0)
	bank_expa_http = Gtk::Expander.new("")
	bank_expa_http.use_markup = true
	bank_expa_http.label = "<b>Unsichere Verbindungen</b>"
	bank_expa_https.expanded = true
	bank_auxbox2.pack_start(bank_expa_http, false, 0, 20)
	
	# An auxiliary HBox to provide the gap left of the checkboxes
	# An VBox to contain the checkboxes
	check_vbox2 = Gtk::VBox.new(false, 0)
	check_hbox2 = Gtk::HBox.new(false, 0)
	xbnode.elements.each("hosts[@class='http']/host") { |host|
		$stderr.puts host.attributes["name"]
		chebo = Gtk::CheckButton.new(host.attributes["name"])
		chebo.active = true if host.attributes["active"] == 'yes'
		chebo.signal_connect("toggled") { |c|
			if c.active? == false
				host.attributes["active"] = 'no' 
				$removed_hosts = true
			else
				host.attributes["active"] = 'yes'
			end
			$stderr.puts xbnode.to_s
		}
		check_vbox2.pack_start(chebo)
	}
	check_hbox2.pack_start(check_vbox2, false, 0, 20)
	bank_expa_http.add(check_hbox2)
	
	bank_box.pack_start(bank_auxbox1, false, 0, 0)
	bank_box.pack_start(bank_auxbox2, false, 0, 0)
	bank_expa.add(bank_box)
	menu = Gtk::Menu.new
	
	eventbox = Gtk::EventBox.new
	eventbox.events = Gdk::Event::BUTTON_PRESS_MASK
	eventbox.signal_connect('button_press_event') do |w, event|
		if event.event_type == Gdk::Event::BUTTON_PRESS
			if event.button == 3   # left mouse button
				menu.popup(nil, nil, event.button, event.time)
			end
		end
	end
	eventbox.add(bank_expa)
	pwidget.pack_start(eventbox, false, 5, 5)
	# window.add(eventbox)
	eventbox.realize
	#bank_expa_http.show
	#bank_expa_https.show
	#bank_auxbox1.show
	#bank_auxbox2.show
	#bank_box.show
	eventbox.show
	bank_expa.show_all
	create_popup(menu, bank_expa, pwidget, window, check_vbox2, xbnode, blz.to_i )
	xbnode.attributes["blz"] = blz.to_s
	xbnode.attributes["name"] = name
	$bankfrags[blz.to_i] = xbnode
end

$blzfile = "/tmp/blzlist.xml"
$blzfile = "/etc/lesslinux/banking/blzlist.xml" if File.exists?("/etc/lesslinux/banking/blzlist.xml")
$cfgdir = "/tmp"
$cfgdir = "/etc/lesslinux/banking" if system("test -d /etc/lesslinux/banking")
$blzxml = REXML::Document.new(File.new($blzfile))
$blzlist = prep_blz_list($blzxml)
$bankfrags = Hash.new
$banknames = Hash.new
$deleted_banks = Array.new
$removed_hosts = false
$outdir = "/tmp/banks"
$outdir = "/etc/smack/banks" if system("test -d /etc/smack/banks")
$blzdir = "../crawlout"
$blzdir = "/etc/lesslinux/banking/descs" if system("test -d /etc/lesslinux/banking/descs")

# banklist = REXML::Document.new(File.new("banklist.xml"))


window = Gtk::Window.new
window.border_width = 10
window.set_size_request(200, -1)
window.title = "Freigegebene Banken"

window.signal_connect('delete_event') { false }
window.signal_connect('destroy') { Gtk.main_quit }


bankbox = Gtk::VBox.new(false, 0)

bpos = 0

scroll_pane = Gtk::ScrolledWindow.new
scroll_pane.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC)
scroll_pane.add_with_viewport(bankbox)

# window.add(scroll_pane)

vlayout = Gtk::VBox.new(false, 0)
vlayout.pack_start(scroll_pane, true, true, 0)
save_butt = Gtk::Button.new("Änderungen anwenden")
vlayout.pack_start(save_butt, false, true, 0)
save_butt.signal_connect("clicked") { write_back(window) }
window.add(vlayout)

if File.exist?($cfgdir + "/allowedservers.xml")
	begin
		xmlf = File.open($cfgdir + "/allowedservers.xml")
		allowedbanks = REXML::Document.new(xmlf)
		xmlf.close
		allowedbanks.elements.each("allowedbanks/bank") { |hostnode|
			puts hostnode.to_s
			blz = hostnode.attributes["blz"].to_i
			name = hostnode.attributes["name"].to_s
			puts blz
			add_bank(hostnode, bankbox, window, blz, name)
		}
	rescue
	end
end

# window.add(expa_codi)

window.set_size_request(400, 450)
window.show_all

select_bank(window, bankbox) if $bankfrags.length < 1

Gtk.main
